Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/AaiSecurityConfiguration.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/AaiSecurityConfiguration.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/config/AaiSecurityConfiguration.java	(revision 61441)
@@ -42,11 +42,6 @@
     @Value("${webapp.dev.front}")
     private String webAppFrontEnd;
 
-    private Map<String, String> userRoles = new HashMap<String, String>(){{
-        put("urn:geant:openaire.eu:group:Super+Administrator#aai.openaire.eu", "ROLE_ADMIN");
-        put("urn:geant:openaire.eu:group:Content+Provider+Dashboard+Administrator#aai.openaire.eu","ROLE_PROVIDE_ADMIN");
-    }};
-
     @Bean
     @Override
     public AuthenticationManager authenticationManagerBean() throws Exception {
@@ -54,12 +49,12 @@
     }
 
     @Override
-    protected void configure(AuthenticationManagerBuilder auth) throws Exception {
+    protected void configure(AuthenticationManagerBuilder auth) {
         auth.authenticationProvider(openIdConnectAuthenticationProvider());
     }
 
     @Override
-    public void configure(WebSecurity web) throws Exception {
+    public void configure(WebSecurity web) {
         web.ignoring().antMatchers("/stats/**");
     }
 
@@ -70,20 +65,20 @@
                 .authorizeRequests()
                 .anyRequest().authenticated()
                 .and()
-                    .httpBasic()
-                    .authenticationEntryPoint(authenticationEntryPoint())
+                .httpBasic()
+                .authenticationEntryPoint(authenticationEntryPoint())
                 .and()
-                    .logout().logoutUrl("/openid_logout")
-                    .invalidateHttpSession(true)
-                    .deleteCookies("openAIRESession")
-                    .logoutSuccessUrl(logoutSuccessUrl)
+                .logout().logoutUrl("/openid_logout")
+                .invalidateHttpSession(true)
+                .deleteCookies("openAIRESession")
+                .logoutSuccessUrl(logoutSuccessUrl)
                 .and()
-                    .addFilterBefore(openIdConnectAuthenticationFilter(), AbstractPreAuthenticatedProcessingFilter.class)
+                .addFilterBefore(openIdConnectAuthenticationFilter(), AbstractPreAuthenticatedProcessingFilter.class)
         ;
     }
 
     @Bean
-    public OIDCAuthenticationProvider openIdConnectAuthenticationProvider(){
+    public OIDCAuthenticationProvider openIdConnectAuthenticationProvider() {
         OIDCAuthenticationProvider oidcProvider = new OIDCAuthenticationProvider();
         oidcProvider.setAuthoritiesMapper(authoritiesMapper());
         return oidcProvider;
@@ -90,13 +85,13 @@
     }
 
     @Bean
-    public OpenAireProviderAuthoritiesMapper authoritiesMapper(){
-        OpenAireProviderAuthoritiesMapper authoritiesMapper = new OpenAireProviderAuthoritiesMapper(userRoles);
+    public OpenAIREAuthoritiesMapper authoritiesMapper() {
+        OpenAIREAuthoritiesMapper authoritiesMapper = new OpenAIREAuthoritiesMapper();
         return authoritiesMapper;
     }
 
     @Bean
-    public StaticServerConfigurationService staticServerConfigurationService(){
+    public StaticServerConfigurationService staticServerConfigurationService() {
         StaticServerConfigurationService staticServerConfigurationService = new StaticServerConfigurationService();
         Map<String, ServerConfiguration> servers = new HashMap<>();
         servers.put(oidcIssuer, serverConfiguration());
@@ -105,20 +100,20 @@
     }
 
     @Bean
-    public StaticClientConfigurationService staticClientConfigurationService(){
+    public StaticClientConfigurationService staticClientConfigurationService() {
         StaticClientConfigurationService staticClientConfigurationService = new StaticClientConfigurationService();
         Map<String, RegisteredClient> clients = new HashMap<>();
-        clients.put(oidcIssuer,registeredClient());
+        clients.put(oidcIssuer, registeredClient());
         staticClientConfigurationService.setClients(clients);
         return staticClientConfigurationService;
     }
 
     @Bean
-    public RegisteredClient registeredClient(){
+    public RegisteredClient registeredClient() {
         RegisteredClient registeredClient = new RegisteredClient();
         registeredClient.setClientId(oidcId);
         registeredClient.setClientSecret(oidcSecret);
-        registeredClient.setScope(new HashSet<>(Arrays.asList("openid","eduperson_entitlement","profile", "email")));
+        registeredClient.setScope(new HashSet<>(Arrays.asList("openid", "eduperson_entitlement", "profile", "email")));
         registeredClient.setTokenEndpointAuthMethod(AuthMethod.SECRET_BASIC);
         registeredClient.setRedirectUris(new HashSet<>(Collections.singletonList(oidcDevHome)));
         return registeredClient;
@@ -125,29 +120,29 @@
     }
 
     @Bean
-    public StaticAuthRequestOptionsService staticAuthRequestOptionsService(){
+    public StaticAuthRequestOptionsService staticAuthRequestOptionsService() {
         return new StaticAuthRequestOptionsService();
     }
 
     @Bean
-    public PlainAuthRequestUrlBuilder plainAuthRequestUrlBuilder(){
+    public PlainAuthRequestUrlBuilder plainAuthRequestUrlBuilder() {
         return new PlainAuthRequestUrlBuilder();
     }
 
     @Bean
-    public ServerConfiguration serverConfiguration(){
+    public ServerConfiguration serverConfiguration() {
         ServerConfiguration serverConfiguration = new ServerConfiguration();
         serverConfiguration.setIssuer(oidcIssuer);
-        serverConfiguration.setAuthorizationEndpointUri(oidcIssuer+"authorize");
-        serverConfiguration.setTokenEndpointUri(oidcIssuer+"token");
-        serverConfiguration.setUserInfoUri(oidcIssuer+"userinfo");
-        serverConfiguration.setJwksUri(oidcIssuer+"jwk");
-        serverConfiguration.setRevocationEndpointUri(oidcIssuer+"revoke");
+        serverConfiguration.setAuthorizationEndpointUri(oidcIssuer + "authorize");
+        serverConfiguration.setTokenEndpointUri(oidcIssuer + "token");
+        serverConfiguration.setUserInfoUri(oidcIssuer + "userinfo");
+        serverConfiguration.setJwksUri(oidcIssuer + "jwk");
+        serverConfiguration.setRevocationEndpointUri(oidcIssuer + "revoke");
         return serverConfiguration;
     }
 
     @Bean
-    public LoginUrlAuthenticationEntryPoint authenticationEntryPoint(){
+    public LoginUrlAuthenticationEntryPoint authenticationEntryPoint() {
         return new LoginUrlAuthenticationEntryPoint("/openid_connect_login");
     }
 
@@ -166,7 +161,7 @@
     }
 
     @Bean
-    public StaticSingleIssuerService staticSingleIssuerService(){
+    public StaticSingleIssuerService staticSingleIssuerService() {
         StaticSingleIssuerService staticSingleIssuerService = new StaticSingleIssuerService();
         staticSingleIssuerService.setIssuer(oidcIssuer);
         return staticSingleIssuerService;
@@ -173,7 +168,7 @@
     }
 
     @Bean(initMethod = "init")
-    public FrontEndLinkURIAuthenticationSuccessHandler frontEndRedirect(){
+    public FrontEndLinkURIAuthenticationSuccessHandler frontEndRedirect() {
         FrontEndLinkURIAuthenticationSuccessHandler frontEnd = new FrontEndLinkURIAuthenticationSuccessHandler();
         frontEnd.setFrontEndURI(webAppFrontEnd);
         return frontEnd;
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/UserController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/UserController.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/UserController.java	(revision 61441)
@@ -18,7 +18,7 @@
     private UserServiceImpl userService;
 
     @RequestMapping(value = "/login" , method = RequestMethod.GET)
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public ResponseEntity<Object> login() {
         return userService.login();
     }
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/UserRoleController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/UserRoleController.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/UserRoleController.java	(revision 61441)
@@ -0,0 +1,110 @@
+package eu.dnetlib.repo.manager.controllers;
+
+import eu.dnetlib.repo.manager.domain.dto.Role;
+import eu.dnetlib.repo.manager.service.aai.registry.AaiRegistryService;
+import eu.dnetlib.repo.manager.service.security.AuthoritiesUpdater;
+import eu.dnetlib.repo.manager.service.security.AuthorizationService;
+import eu.dnetlib.repo.manager.service.security.RoleMappingService;
+import eu.dnetlib.repo.manager.utils.JsonUtils;
+import io.swagger.annotations.Api;
+import io.swagger.annotations.ApiOperation;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.security.access.prepost.PreAuthorize;
+import org.springframework.web.bind.annotation.*;
+
+import javax.ws.rs.core.MediaType;
+import javax.ws.rs.core.Response;
+import java.util.Collection;
+
+@RestController
+@RequestMapping(value = "/role-management")
+@Api(description = "Role Management", value = "role-management")
+public class UserRoleController {
+
+    private final AaiRegistryService aaiRegistryService;
+    private final AuthoritiesUpdater authoritiesUpdater;
+    private final RoleMappingService roleMappingService;
+    private final AuthorizationService authorizationService;
+
+    @Autowired
+    UserRoleController(AaiRegistryService aaiRegistryService,
+                       AuthoritiesUpdater authoritiesUpdater,
+                       RoleMappingService roleMappingService,
+                       AuthorizationService authorizationService) {
+        this.aaiRegistryService = aaiRegistryService;
+        this.authoritiesUpdater = authoritiesUpdater;
+        this.roleMappingService = roleMappingService;
+        this.authorizationService = authorizationService;
+    }
+
+    /**
+     * Get the role with the given id.
+     **/
+    @RequestMapping(method = RequestMethod.GET, path = "/role/{id}")
+//    @PreAuthorize("hasAnyAuthority('REGISTERED_USER', 'SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
+    public Response getRole(@RequestParam(value = "type", defaultValue = "datasource") String type, @PathVariable("id") String id) {
+        int roleId = aaiRegistryService.getCouId(type, id);
+        return Response.status(HttpStatus.OK.value()).entity(JsonUtils.createResponse("Role id is: " + roleId).toString()).type(MediaType.APPLICATION_JSON).build();
+    }
+
+    /**
+     * Create a new role with the given name and description.
+     **/
+    @RequestMapping(method = RequestMethod.POST, path = "/role")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR')")
+    public Response createRole(@RequestBody Role role) {
+        aaiRegistryService.createRole(role);
+        return Response.status(HttpStatus.OK.value()).entity(JsonUtils.createResponse("Role has been created").toString()).type(MediaType.APPLICATION_JSON).build();
+    }
+
+    /**
+     * Subscribe to a type(Community, etc.) with id(ee, egi, etc.)
+     */
+    @ApiOperation(value = "subscribe")
+    @RequestMapping(method = RequestMethod.POST, path = "/subscribe/{type}/{id}")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
+    public Response subscribe(@PathVariable("type") String type, @PathVariable("id") String id) {
+        Integer coPersonId = aaiRegistryService.getCoPersonIdByIdentifier();
+        if (coPersonId == null) {
+            coPersonId = aaiRegistryService.getCoPersonIdByEmail();
+        }
+        Integer couId = aaiRegistryService.getCouId(type, id);
+        if (couId != null) {
+            Integer role = aaiRegistryService.getRoleId(coPersonId, couId);
+            aaiRegistryService.assignMemberRole(coPersonId, couId, role);
+
+            // Add role to current authorities
+            authoritiesUpdater.addRole(roleMappingService.convertRepoIdToAuthority(id));
+
+            return Response.status(HttpStatus.OK.value()).entity(JsonUtils.createResponse("Role has been assigned").toString()).type(MediaType.APPLICATION_JSON).build();
+        } else {
+            return Response.status(HttpStatus.NOT_FOUND.value()).entity(JsonUtils.createResponse("Role has not been found").toString()).type(MediaType.APPLICATION_JSON).build();
+        }
+    }
+    /////////////////////////////////////////////////////////////////////////////////////////////
+    /////////////////////////////////////////////////////////////////////////////////////////////
+
+    @RequestMapping(method = RequestMethod.GET, path = "/users/couid/{id}")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
+    public ResponseEntity<String> getUsersByCouId(@PathVariable("id") Integer id) {
+//        calls.getUserByCoId()
+        return ResponseEntity.ok(aaiRegistryService.getUsersByCouId(id).toString());
+    }
+
+
+    @RequestMapping(method = RequestMethod.GET, path = "/users/{email}/roles")
+    @PreAuthorize("hasAnyAuthority('SUPER_ADMINISTRATOR', 'CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or hasAuthority('REGISTERED_USER') and authentication.userInfo.email==#email")
+    public ResponseEntity<Collection<String>> getRolesByEmail(@PathVariable("email") String email) {
+        return ResponseEntity.ok(authorizationService.getUserRoles(email));
+    }
+
+
+    @RequestMapping(method = RequestMethod.GET, path = "/user/roles/my")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
+    public ResponseEntity<Collection<String>> getRoleNames() {
+        return ResponseEntity.ok(authorizationService.getUserRoles());
+    }
+
+}
\ No newline at end of file
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/BrokerController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/BrokerController.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/BrokerController.java	(revision 61441)
@@ -30,7 +30,7 @@
     @RequestMapping(value = "/getDatasourcesOfUser" , method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public DatasourcesBroker getDatasourcesOfUser(
                                            @RequestParam("includeShared")
                                            @ApiParam(value = "Include shared datasources", required = true , defaultValue = "false") String includeShared,
@@ -51,7 +51,7 @@
             method = RequestMethod.POST,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public EventsPage advancedShowEvents(@PathVariable("page") String page,
                                   @PathVariable("size") String size,
                                   @RequestBody AdvQueryObject advQueryObject) throws BrokerException, JSONException ,IOException{
@@ -62,7 +62,7 @@
             method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public EventsPage showEvents(@RequestParam("datasourceName") String datasourceName,
                           @RequestParam("topic") String topic,
                           @RequestParam("page") String page,
@@ -74,7 +74,7 @@
             method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public Map<String, List<SimpleSubscriptionDesc>> getSimpleSubscriptionsOfUser() throws BrokerException{
         return brokerService.getSimpleSubscriptionsOfUser(((OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication()).getUserInfo().getEmail());
     }
@@ -83,7 +83,7 @@
             consumes = MediaType.APPLICATION_JSON_VALUE,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER') ")
+    @PreAuthorize("hasAuthority('REGISTERED_USER') ")
     public Subscription subscribe(@RequestBody OpenaireSubscription obj) throws BrokerException{
         return brokerService.subscribe(obj);
     }
@@ -92,7 +92,7 @@
             consumes = MediaType.APPLICATION_JSON_VALUE,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public ResponseEntity<Object> unsubscribe(@PathVariable("subscriptionId") String subscriptionId) throws BrokerException{
         return brokerService.unsubscribe(subscriptionId);
     }
@@ -100,7 +100,7 @@
     @RequestMapping(value = "/getSubscription/{subscriptionId}" , method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public Subscription getSubscription(@PathVariable("subscriptionId") String subscriptionId) throws BrokerException{
         return brokerService.getSubscription(subscriptionId);
     }
@@ -116,7 +116,7 @@
     @RequestMapping(value = "/getNotificationsBySubscriptionId/{subscriptionId}/{page}/{size}" , method = RequestMethod.GET
             ,produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public EventsPage getNotificationsBySubscriptionId(@PathVariable("subscriptionId") String subscriptionId,
                                                 @PathVariable("page") String page,
                                                 @PathVariable("size") String size) throws BrokerException{
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/DashboardController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/DashboardController.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/DashboardController.java	(revision 61441)
@@ -36,7 +36,7 @@
     @RequestMapping(value = "/getRepositoriesSummary/{page}/{size}" , method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public List<RepositorySummaryInfo> getRepositoriesSummaryInfo(
                                                                   @PathVariable("page") String page,
                                                                   @PathVariable("size") String size) throws JSONException {
@@ -46,7 +46,7 @@
     @RequestMapping(value = "/collectionMonitorSummary/{repoId}" , method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public CollectionMonitorSummary getCollectionMonitorSummary(
             @PathVariable("repoId") String repoId,
             @RequestParam(name = "size", required = false, defaultValue = "20") int size) throws JSONException {
@@ -72,7 +72,7 @@
     @RequestMapping(value = "/usageSummary/{repoId}" , method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public UsageSummary getUsageSummary(
             @PathVariable("repoId") String repoId
     ) throws RepositoryServiceException {
@@ -82,7 +82,7 @@
     @RequestMapping(value = "/brokerSummary/{ds_name}" , method = RequestMethod.GET,
             produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public BrokerSummary getBrokerSummary(
             @PathVariable("ds_name") String datasourceName) throws BrokerException {
         return new BrokerSummary(brokerService.getSimpleSubscriptionsOfUser( ((OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication()).getUserInfo().getEmail()), brokerService.getTopicsForDatasource(datasourceName));
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/SushiliteController.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/SushiliteController.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/controllers/SushiliteController.java	(revision 61441)
@@ -19,7 +19,7 @@
 
     @RequestMapping(value = "/getReportResults/{page}/{pageSize}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
     @ResponseBody
-    @PreAuthorize("hasRole('ROLE_USER')")
+    @PreAuthorize("hasAuthority('REGISTERED_USER')")
     public ReportResponseWrapper getReportResults(@PathVariable("page") String page,
                                                   @PathVariable("pageSize") String pageSize,
                                                   @RequestParam(value = "Report") String Report,
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/domain/RepositorySnippet.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/domain/RepositorySnippet.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/domain/RepositorySnippet.java	(revision 61441)
@@ -7,6 +7,7 @@
 
 public class RepositorySnippet {
 
+    // Do not refactor names to keep compatibility with external api.
     private String id;
     private String officialname;
     private String englishname;
@@ -24,7 +25,8 @@
 
     private PiwikInfo piwikInfo;
 
-    public RepositorySnippet() {}
+    public RepositorySnippet() {
+    }
 
     public String getId() {
         return id;
